**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              Travail2.gms
Sequence         2 - Le modle d'exploitation agricole
Type             LP
Langage GAMS     Tableaux  3 dimensions. Equations indices
Description
"Soit une exploitation agricole qui peut pratiquer trois cultures, le bl, le mas et la tomate,
et deux itinraires techniques, extensif et intensif.
On cherche  dterminer la superficie  cultiver dans chaque culture et la technique  utiliser, sachant que :
Lobjectif de lagriculteur est la maximisation du revenu.

Les besoins en travail sont de :
                 Besoin en eau (m3)
Technique        extensif        intensif
Bl              0               2
Mais             4               6
Tomate           3               5

 Les besoins en travail sont de :
         Besoin en travail (h/ha)
         Technique         Priode
                      Hiver        Ete
Bl      extensif        10        5
         intensif        15        10
Mais     extensif        10        35
         Intensif        10        40
Tomate   extensif        10        70
         Intensif        10        90

Les marges brutes sont variables suivant les annes. Les dix dernire annes elles taient de :
             A1     A2     A3    A4    A5   A6    A7    A8    A9   A10
ble   .ext   415   540   335   360   300   405   490   265   600   540
ble   .int   424   744   364   374   324   564   374   284   474   574
mais  .ext   365  1170   770   730   850   790  1180   610   925   610
mais  .int   600  1310   810   990   900   870  1710   630  1350   830
tomate.ext  1940   230  2200   785  1120  2050   785  1600  1305    35
tomate.int  1865   240  3635   705  2005  2285  1005  2735  1645   -20

Le prix de vente est de 150/tonne pour le bl, 150/tonne pour le mas et 185/tonne pour la tomate.
La surface de lexploitation est de 50 ha, lagriculteur dispose de 2000 heures de travail par an
et dispose de 150 milliers de m3 pour lirrigation.
L'agriculteur a la possibilit d'embaucher des salaris  10 de l'heure,
d'acheter de l'eau au prix de 50 par millier de m3
et de louer de la terre  500/ha."

$offtext


*                MODELE AGRICOLE SANS RISQUE                     *
*               Achat terre main d'oeuvre et irrigation       *
*               Introduction de techniques extensives

*~~~~~~~~~~~~~~~~~~~~~~~~ INDICES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
sets   C cultures     /ble,mais,tomate/
       T techniques   /ext extensive,int intensive/
       P periodes     /hiver ,ete /
       K etats de la nature de la marge brute  /K01*K10/
;

*~~~~~~~~~~~~~~~~~~~~~~~~ DONNEES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
scalar
DTERRE disponibilite de terre en hectares        /50/
DEAU   disponibilite en eau (milliers m3)        /150/
PMO    prix horaire du travail salariee en euros /10/
pterre prix du fermage en euros par ha par an    /500/
peau   prix eau en euros par millier  m3         /50/
revmin revenu minimum                            /18000/
;

parameter
prob(K) probabilit d'occurance de l'tat de la nature K
;
prob(K)=1/card(K)
*la probabilit est rpartie uniformment
;


parameter
DMO(P) disponibilite en travail par periode (heures)
/hiver  1000
 ete    1000/
;


table BMO(C,T,P) besoins en travail par culture et technique (heures par hectare)
             hiver   ete
 ble.ext        10     5
 ble.int        15    10
 mais.ext       10    35
 mais.int       10    40
 tomate.ext     10    70
 tomate.int     10    90
;
table BEAU(C,T) besoins en eau par culture et technique (en milliers m3 par hectare)
          ext    int
 ble        0      2
 mais       4      6
 tomate     3      5
;

 table MBK(C,T,K) marge brute par culture technique et etat de nature (euros)
             K01   K02   K03   K04   K05   K06   K07   K08   K09   K10
ble   .ext   415   540   335   360   300   405   490   265   600   540
ble   .int   424   744   364   374   324   564   374   284   474   574
mais  .ext   365  1170   770   730   850   790  1180   610   925   610
mais  .int   600  1310   810   990   900   870  1710   630  1350   830
tomate.ext  1940   230  2200   785  1120  2050   785  1600  1305    35
tomate.int  1865   240  3635   705  2005  2285  1005  2735  1645   -20
;


parameter
MBM(C,T) marge brute moyenne calculee pour chaque couple culture technique ;
MBM(C,T) = sum(k,MBK(C,T,K))/10 ;

*~~~~~~~~~~~~~~~~~~~~~~~~ MODELE  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
variables
X(C,T)   surfaces dans les diffrentes productions selon les differentes techniques
MOS(p)   main d oeuvre salariee (heures)
aeau     achat supplementaire eau (1000 m3)
lterre   location supplementaire de terre (ha)

;

positive variables
X, aeau, lterre, MOS
;

Equations
revenu           fonction objectif
Ter              contrainte de disponibilite en terre
EAU              contrainte de disponibilite en eau
Trav(P)          contrainte de disponibilite en travail par periode

;



model agri /all/ ;

Solve agri using NLP maximizing RM ;


